"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var index_exports = {};
__export(index_exports, {
  AttachmentType: () => AttachmentType,
  CrmAttachmentAttachmentType: () => CrmAttachmentAttachmentType,
  DemoContactType: () => DemoContactType,
  WebhookIdentityType: () => WebhookIdentityType,
  deleteAttachment: () => deleteAttachment4,
  generateAttachmentUploadUrl: () => generateAttachmentUploadUrl4,
  getAttachment: () => getAttachment4,
  listAttachments: () => listAttachments4,
  onAttachmentCreated: () => onAttachmentCreated2,
  onAttachmentDeleted: () => onAttachmentDeleted2
});
module.exports = __toCommonJS(index_exports);

// src/contacts-v4-attachment-attachments.public.ts
var import_rename_all_nested_keys2 = require("@wix/sdk-runtime/rename-all-nested-keys");
var import_document2 = require("@wix/sdk-runtime/transformations/document");
var import_image2 = require("@wix/sdk-runtime/transformations/image");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths3 = require("@wix/sdk-runtime/transformations/transform-paths");
var import_sdk_types = require("@wix/sdk-types");

// src/contacts-v4-attachment-attachments.universal.ts
var import_transform_error = require("@wix/sdk-runtime/transform-error");
var import_rename_all_nested_keys = require("@wix/sdk-runtime/rename-all-nested-keys");

// src/contacts-v4-attachment-attachments.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressContactsAttachmentsV4ContactAttachmentsServiceV4Url(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/contacts-attachments-app",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/attachments",
        destPath: "/v4/attachments"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/attachments",
        destPath: "/v4/attachments"
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/attachments",
        destPath: "/v4/attachments"
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/attachments",
        destPath: "/v4/attachments"
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/contacts/v4/attachments",
        destPath: "/v4/attachments"
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/contacts/v4/attachments",
        destPath: "/v4/attachments"
      }
    ],
    _: [
      {
        srcPath: "/_api/contacts/v4/attachments",
        destPath: "/v4/attachments"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/contacts/v4/attachments",
        destPath: "/v4/attachments"
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_crm_attachments";
function generateAttachmentUploadUrl(payload) {
  function __generateAttachmentUploadUrl({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.attachment",
      method: "POST",
      methodFqn: "com.wixpress.contacts.attachments.v4.ContactAttachmentsServiceV4.GenerateAttachmentUploadUrl",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsAttachmentsV4ContactAttachmentsServiceV4Url(
        {
          protoPath: "/v4/attachments/{contactId}/upload-url",
          data: payload,
          host
        }
      ),
      data: payload
    };
    return metadata;
  }
  return __generateAttachmentUploadUrl;
}
function listAttachments(payload) {
  function __listAttachments({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.attachment",
      method: "GET",
      methodFqn: "com.wixpress.contacts.attachments.v4.ContactAttachmentsServiceV4.ListAttachments",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsAttachmentsV4ContactAttachmentsServiceV4Url(
        { protoPath: "/v4/attachments/{contactId}", data: payload, host }
      ),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "attachments.image.urlExpirationDate" },
            { path: "attachments.document.urlExpirationDate" },
            { path: "attachments.previewImage.urlExpirationDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __listAttachments;
}
function deleteAttachment(payload) {
  function __deleteAttachment({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.attachment",
      method: "DELETE",
      methodFqn: "com.wixpress.contacts.attachments.v4.ContactAttachmentsServiceV4.DeleteAttachment",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsAttachmentsV4ContactAttachmentsServiceV4Url(
        {
          protoPath: "/v4/attachments/{contactId}/{attachmentId}",
          data: payload,
          host
        }
      ),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __deleteAttachment;
}
function getAttachment(payload) {
  function __getAttachment({ host }) {
    const metadata = {
      entityFqdn: "wix.contacts.v4.attachment",
      method: "GET",
      methodFqn: "com.wixpress.contacts.attachments.v4.ContactAttachmentsServiceV4.GetAttachment",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsAttachmentsV4ContactAttachmentsServiceV4Url(
        {
          protoPath: "/v4/attachments/{contactId}/{attachmentId}",
          data: payload,
          host
        }
      ),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "attachment.image.urlExpirationDate" },
            { path: "attachment.document.urlExpirationDate" },
            { path: "attachment.previewImage.urlExpirationDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getAttachment;
}

// src/contacts-v4-attachment-attachments.universal.ts
var import_image = require("@wix/sdk-runtime/transformations/image");
var import_document = require("@wix/sdk-runtime/transformations/document");
var import_transform_paths2 = require("@wix/sdk-runtime/transformations/transform-paths");
var AttachmentType = /* @__PURE__ */ ((AttachmentType2) => {
  AttachmentType2["UNKNOWN"] = "UNKNOWN";
  AttachmentType2["IMAGE"] = "IMAGE";
  AttachmentType2["OTHER"] = "OTHER";
  return AttachmentType2;
})(AttachmentType || {});
var CrmAttachmentAttachmentType = /* @__PURE__ */ ((CrmAttachmentAttachmentType2) => {
  CrmAttachmentAttachmentType2["UNKNOWN"] = "UNKNOWN";
  CrmAttachmentAttachmentType2["DOCUMENT"] = "DOCUMENT";
  CrmAttachmentAttachmentType2["IMAGE"] = "IMAGE";
  return CrmAttachmentAttachmentType2;
})(CrmAttachmentAttachmentType || {});
var DemoContactType = /* @__PURE__ */ ((DemoContactType2) => {
  DemoContactType2["KAT"] = "KAT";
  DemoContactType2["DAN"] = "DAN";
  return DemoContactType2;
})(DemoContactType || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function generateAttachmentUploadUrl2(contactId, fileName, options) {
  const { httpClient, sideEffects } = arguments[3];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    contactId,
    fileName,
    mimeType: options?.mimeType
  });
  const reqOpts = generateAttachmentUploadUrl(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          contactId: "$[0]",
          fileName: "$[1]",
          mimeType: "$[2].mimeType"
        },
        singleArgumentUnchanged: false
      },
      ["contactId", "fileName", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function listAttachments2(contactId, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    contactId,
    paging: options?.paging
  });
  const reqOpts = listAttachments(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image.transformRESTImageToSDKImage,
          paths: [
            { path: "attachments.image" },
            { path: "attachments.previewImage" }
          ]
        },
        {
          transformFn: import_document.transformRESTDocumentToSDKDocument,
          paths: [{ path: "attachments.document" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { contactId: "$[0]", paging: "$[1].paging" },
        singleArgumentUnchanged: false
      },
      ["contactId", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function deleteAttachment2(identifiers) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    contactId: identifiers?.contactId,
    attachmentId: identifiers?.attachmentId
  });
  const reqOpts = deleteAttachment(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          contactId: "$[0].contactId",
          attachmentId: "$[0].attachmentId"
        },
        singleArgumentUnchanged: false
      },
      ["identifiers"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function getAttachment2(identifiers) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    contactId: identifiers?.contactId,
    attachmentId: identifiers?.attachmentId
  });
  const reqOpts = getAttachment(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image.transformRESTImageToSDKImage,
          paths: [
            { path: "attachment.image" },
            { path: "attachment.previewImage" }
          ]
        },
        {
          transformFn: import_document.transformRESTDocumentToSDKDocument,
          paths: [{ path: "attachment.document" }]
        }
      ])
    )?.attachment;
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          contactId: "$[0].contactId",
          attachmentId: "$[0].attachmentId"
        },
        singleArgumentUnchanged: false
      },
      ["identifiers"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/contacts-v4-attachment-attachments.public.ts
function generateAttachmentUploadUrl3(httpClient) {
  return (contactId, fileName, options) => generateAttachmentUploadUrl2(
    contactId,
    fileName,
    options,
    // @ts-ignore
    { httpClient }
  );
}
function listAttachments3(httpClient) {
  return (contactId, options) => listAttachments2(
    contactId,
    options,
    // @ts-ignore
    { httpClient }
  );
}
function deleteAttachment3(httpClient) {
  return (identifiers) => deleteAttachment2(
    identifiers,
    // @ts-ignore
    { httpClient }
  );
}
function getAttachment3(httpClient) {
  return (identifiers) => getAttachment2(
    identifiers,
    // @ts-ignore
    { httpClient }
  );
}
var onAttachmentCreated = (0, import_sdk_types.EventDefinition)(
  "wix.contacts.v4.attachment_created",
  true,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths3.transformPaths)(event, [
      {
        transformFn: import_image2.transformRESTImageToSDKImage,
        paths: [{ path: "entity.image" }, { path: "entity.previewImage" }]
      },
      {
        transformFn: import_document2.transformRESTDocumentToSDKDocument,
        paths: [{ path: "entity.document" }]
      },
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [{ path: "metadata.eventTime" }]
      }
    ])
  )
)();
var onAttachmentDeleted = (0, import_sdk_types.EventDefinition)(
  "wix.contacts.v4.attachment_deleted",
  true,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths3.transformPaths)(event, [
      {
        transformFn: import_image2.transformRESTImageToSDKImage,
        paths: [
          { path: "undefined.image" },
          { path: "undefined.previewImage" }
        ]
      },
      {
        transformFn: import_document2.transformRESTDocumentToSDKDocument,
        paths: [{ path: "undefined.document" }]
      },
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [{ path: "metadata.eventTime" }]
      }
    ])
  )
)();

// src/contacts-v4-attachment-attachments.context.ts
var import_rest_modules3 = require("@wix/sdk-runtime/rest-modules");
var import_event_definition_modules = require("@wix/sdk-runtime/event-definition-modules");
var generateAttachmentUploadUrl4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(generateAttachmentUploadUrl3);
var listAttachments4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(listAttachments3);
var deleteAttachment4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(deleteAttachment3);
var getAttachment4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(getAttachment3);
var onAttachmentCreated2 = (0, import_event_definition_modules.createEventModule)(onAttachmentCreated);
var onAttachmentDeleted2 = (0, import_event_definition_modules.createEventModule)(onAttachmentDeleted);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AttachmentType,
  CrmAttachmentAttachmentType,
  DemoContactType,
  WebhookIdentityType,
  deleteAttachment,
  generateAttachmentUploadUrl,
  getAttachment,
  listAttachments,
  onAttachmentCreated,
  onAttachmentDeleted
});
//# sourceMappingURL=index.js.map